VERSION 5.00
Begin VB.Form ScTransDrop 
   AutoRedraw      =   -1  'True
   BackColor       =   &H8000000A&
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "Scenalyser/StudioDV Scenelist Converter 1 beta"
   ClientHeight    =   5064
   ClientLeft      =   4128
   ClientTop       =   3204
   ClientWidth     =   6132
   Icon            =   "ScTransDrop.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   5064
   ScaleWidth      =   6132
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.TextBox protocol 
      BeginProperty Font 
         Name            =   "Courier"
         Size            =   7.8
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4812
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Beides
      TabIndex        =   0
      Text            =   "ScTransDrop.frx":27A2
      Top             =   120
      Width           =   5892
   End
   Begin VB.Label Label1 
      BackStyle       =   0  'Transparent
      Height          =   5052
      Left            =   0
      TabIndex        =   1
      ToolTipText     =   "http://www.freenet.de/codecpage"
      Top             =   0
      Width           =   6132
   End
End
Attribute VB_Name = "ScTransDrop"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub Form_Load()
    Dim numscenesloc, lengthindex, i1, i2 As Integer
    Dim videofile, outfile, finish As String
    finish = "finished"
    Dim fs
    Set fs = CreateObject("Scripting.FileSystemObject")
        
    Rem do not declare the Integers and longs that are used for binary write to file
    Rem (results in total mess because VB inadvertently turns them into floats !!!!)
    Rem use % and & notation instead.
    
    Rem sourcefile = Command: Rem commandline w. which program was called
    sourcefile = Command: Rem command line = location of dropped file
    Rem rem remove "" if there
    If Left(sourcefile, 1) = Chr$(34) Then sourcefile = Mid(sourcefile, 2, Len(sourcefile) - 2)

    protocol.Text = "": Rem clear protocol window
    protocol.Text = protocol.Text + Chr$(13) + Chr$(10) + "convert  " + Chr$(34) + sourcefile + Chr$(34)
    
    On Error GoTo ErrorHandler
    Open sourcefile For Input As 1
    Input #1, a$: Rem header line
    If Left$(a$, 8) <> "Filename" Then Err.Raise 75
    
    Input #1, a$
    
NewVideoFile:     Rem re-entry if new video file starts
    
    protocol.Text = protocol.Text + Chr$(13) + Chr$(10) + " "
    numscenes% = 1: framenumber0& = 0
    Rem get path/name of source video file
    i2 = Len(a$)
      Do
      i2 = i2 - 1
      Loop Until Mid$(a$, i2, 1) = Chr$(9): Rem items are separated by tabs
    i1 = i2
      Do
      i1 = i1 - 1
      Loop Until Mid$(a$, i1, 1) = Chr$(9)
    vleft = i1 + 1: vlen = i2 - i1 - 1
    videofile = Mid$(a$, vleft, vlen)
    protocol.Text = protocol.Text + Chr$(13) + Chr$(10) + "source   video file: " + Chr$(34) + videofile + Chr$(34)
    If LCase(Right$(videofile, 3)) <> "avi" Then Err.Raise 75
      
      Rem one more backsearch for scene length value
      Do
      i1 = i1 - 1
      Loop Until Mid$(a$, i1, 1) = Chr$(9)
      lengthindex = i1
    
    Rem make path/name of output file
    outfile = Left$(videofile, Len(videofile) - 4) + ".scn"
    protocol.Text = protocol.Text + Chr$(13) + Chr$(10) + "generate scene list: " + Chr$(34) + outfile + Chr$(34): Rem display
        
    If fs.fileexists(outfile) Then
        Response = MsgBox(outfile + " already exists - overwrite ?", vbYesNo, "ScTrans")
        If Response = 2 Then finish = "aborted": GoTo ExitAll: Rem Cancel (not yet implemented)
        If Response = 7 Then finish = "aborted": GoTo ExitAll: Rem No (all or nothing)
        If Response = 6 Then Kill outfile: Rem Yes
    End If

    Open outfile For Binary As #2

    protocol.Text = protocol.Text + Chr$(13) + Chr$(10) + "scene#  start        length    1stframe lastframe"
    Rem precalculate 1st scene length
        frmx$ = Mid$(a$, lengthindex - 2, 2)
        secx$ = Mid$(a$, lengthindex - 5, 2)
        minx$ = Mid$(a$, lengthindex - 8, 2)
        horx$ = Mid$(a$, lengthindex - 10, 1)
        Rem if no hours there, its the yes/no flag, which will return 0
    framenumber1& = Val(frmx$) + Val(secx$) * 25 + Val(minx$) * 25 * 60 + Val(horx$) * 25 * 60 * 60
      
        protocol.Text = protocol.Text + Chr$(13) + Chr$(10) + Str$(numscenes) + Chr$(9) + Right$(a$, 8) + "      " + Mid$(a$, lengthindex - 7, 8) + Str$(framenumber0&) + Chr$(9) + Str$(framenumber1&)
    
    Rem build/write scene file header
    filepointer = 1
    b$ = ""
    b$ = b$ + Chr(&H63) + Chr(&H26) + Chr(&H1) + Chr(&H0)
    b$ = b$ + Chr(&H4) + Chr(&H0) + Chr(&H0) + Chr(&H0)
    b$ = b$ + Chr(&HFF) + Chr(&HFF) + Chr(&H3) + Chr(&H0) + Chr(&HA) + Chr(&H0)
    b$ = b$ + "SourceTape"
    b$ = b$ + Chr(Len(videofile)) + videofile
    b$ = b$ + Chr(&H0) + Chr(&H0) + Chr(&H0) + Chr(&H0) + Chr(&H0) + Chr(&H0)
    b$ = b$ + Chr(&H0) + Chr(&H0): Rem or &HC +&H0
    b$ = b$ + Chr(&H0) + Chr(&H0)
        numscenesloc = Len(b$) - 1: Rem number of scenes will be patched here when finished
    b$ = b$ + Chr(&HFF) + Chr(&HFF) + Chr(&H1) + Chr(&H0) + Chr(&H4) + Chr(&H0)
    b$ = b$ + "ClipP"
    b$ = b$ + Chr(&H0) + Chr(&H0) + Chr(&H0) + Chr(&HFF)
    b$ = b$ + Chr(&HFF) + Chr(&H1) + Chr(&H0) + Chr(&H5) + Chr(&H0)
    b$ = b$ + "Scene"
    b$ = b$ + Chr(&H0) + Chr(&H0) + Chr(&H0) + Chr(&H0) + Chr(&H0)
    Put #2, filepointer, b$: filepointer = filepointer + Len(b$)
        Put #2, filepointer, framenumber1&: Rem long integer saved LSB first
        filepointer = filepointer + 4:
    b$ = Chr(&H0) + Chr(&H0) + Chr(&H0) + Chr(&H0) + Chr(&H1) + Chr(&H80)
    Put #2, filepointer, b$: filepointer = filepointer + Len(b$)
    b$ = Chr(Len(videofile)) + videofile
    Put #2, filepointer, b$: filepointer = filepointer + Len(b$)
    b$ = Chr(&H0) + Chr(&H0) + Chr(&H0) + Chr(&H0) + Chr(&H0) + Chr(&H0)
    b$ = b$ + Chr(&H0) + Chr(&H0): Rem or &HC +&H0
        Put #2, filepointer, b$: filepointer = filepointer + Len(b$)
        Put #2, filepointer, framenumber1&: Rem long integer saved LSB first
        filepointer = filepointer + 4:
    
    Rem Header finished, now follow the scene entries 2...n
    
SubsequentScenes:
    
    Input #1, a$
        Rem check if new file starts
        If videofile <> Mid$(a$, vleft, vlen) Then Put #2, numscenesloc, numscenes%: Close #2: GoTo NewVideoFile
        Rem If yes, write number of scenes, close and start next one
        
        numscenes% = numscenes% + 1: Rem if read was success, increment # of scenes
        If numscenes% > 16380 Then Err.Raise 75: Rem safety break
    
    framenumber0& = framenumber1&: Rem remember last scene end
        frmx$ = Mid$(a$, lengthindex - 2, 2)
        secx$ = Mid$(a$, lengthindex - 5, 2)
        minx$ = Mid$(a$, lengthindex - 8, 2)
        horx$ = Mid$(a$, lengthindex - 10, 1): Rem if no hours there, its the filename, which will return 0
    framenumber1& = framenumber1& + Val(frmx$) + Val(secx$) * 25 + Val(minx$) * 25 * 60 + Val(horx$) * 25 * 60 * 60
    scenelength& = framenumber1& - framenumber0&
    
    protocol.Text = protocol.Text + Chr$(13) + Chr$(10) + Str$(numscenes) + Chr$(9) + Right$(a$, 8) + "      " + Mid$(a$, lengthindex - 7, 8) + Str$(framenumber0&) + Chr$(9) + Str$(framenumber1&)
    
    Rem build/write scene record
    b$ = Chr(&H3) + Chr(&H80) + Chr(&HF0) + Chr(&H0)
    b$ = b$ + Chr(&H0) + Chr(&H0) + Chr(&H5) + Chr(&H80) + Chr(&H0)
    Put #2, filepointer, b$: filepointer = filepointer + Len(b$)
        Put #2, filepointer, framenumber0&: Rem long integer saved LSB first
        Put #2, filepointer + 4, scenelength&
        filepointer = filepointer + 8
    b$ = Chr(&H0) + Chr(&H0) + Chr(&H0) + Chr(&H0) + Chr(&H7) + Chr(&H0)
    Put #2, filepointer, b$: filepointer = filepointer + Len(b$)
    Put #2, filepointer, b$: Rem fillstuff
        Put #2, filepointer, framenumber0&: Rem long integer saved LSB first
        Put #2, filepointer + 4, scenelength&
        Put #2, filepointer + 8, framenumber0&
        filepointer = filepointer + 12
    
    GoTo SubsequentScenes
    
ErrorHandler:     Rem usually will jump here at end of input file
    
    If Err.Number = 52 Or Err.Number = 53 Then Resume Next: Rem file not found (output file)
    If Err = 75 Then
        protocol.Text = protocol.Text + Chr$(13) + Chr$(10) + " "
        protocol.Text = protocol.Text + Chr$(13) + Chr$(10) + "error accessing file"
        protocol.Text = protocol.Text + Chr$(13) + Chr$(10) + " "
        protocol.Text = protocol.Text + Chr$(13) + Chr$(10) + "Start this application by dropping a valid"
        protocol.Text = protocol.Text + Chr$(13) + Chr$(10) + "Scenalyzer 3.0 file onto the program icon and"
        protocol.Text = protocol.Text + Chr$(13) + Chr$(10) + "make sure the output file is not write protected"
        protocol.Text = protocol.Text + Chr$(13) + Chr$(10)
        protocol.Text = protocol.Text + Chr$(13) + Chr$(10) + "http://www.freenet.de/codecpage"
        protocol.Text = protocol.Text + Chr$(13) + Chr$(10) + "codecbox@email.com"
        
        GoTo ExitAll
    End If
    If Err = 5 Then protocol.Text = protocol.Text + Chr$(13) + Chr$(10) + "file not found": GoTo ExitAll: Rem can also be other error BTW
    If Err.Number <> 62 Then protocol.Text = protocol.Text + Chr$(13) + Chr$(10) + Str$(Err.Number) + " " + Err.Description: GoTo ExitAll: Rem 62 is end of file
       
        Put #2, numscenesloc, numscenes%: Rem 2 byte value LSB first patched into file
        Rem now the outfile is finished
    
ExitAll:
    On Error Resume Next
    Close #1
    Close #2
    protocol.Text = protocol.Text + Chr$(13) + Chr$(10) + " "
    protocol.Text = protocol.Text + Chr$(13) + Chr$(10) + "processing " + finish
End Sub

